# Elements de correction

## Découverte des outils du développeur

Sur <https://perdu.com>

- Chromium est un navigateur qui n'utilise que la base _libre_ de Chrome, sans les ajouts _fermés_ de Google à Chrome
- En cliquant sur le cadenas et en affichant les détails. On peut aussi les voir dans le sous-onglet _Security_ de _Network_ dans les _DevTools_.
- Choisir le sous-onglet _Response_ et activer le toggle _raw_.
- Ctrl-U
- L'icône de smartphone en haut à droite des DevTools, Ctrl-Shift-M. Ceci permet de simuler une navigation depuis un autre dispositif que le desktop.
- Chaque sous question :
  - `last-modified, Thu, 02 Jun 2016 06:01:08 GMT`
  - `User-Agent Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:102.0) Gecko/20100101 Firefox/102.0`
  - `Server Apache`
  - non, rien dans le sous-onglet _Cookies_

Avec le <https://romulusfr.github.io/unc-s2-web-ihm/>

- on passe de _200_ (`OK`) à _304_ (`Not Modified`) car la page est déjà dans le cache du navigateur
- on force le raffraichissement en oubliant la version dans le cache
- 9 requêtes : 1 HTML, 3 CSS, 1 fonte, 3 images jpg + 1 favicon (404)

Avec l'inspecteur

- _Jekyll v3.9.2_, via les GitHub pages
- `body > header > div > a > h1`.
- c'est dans la CSS que c'est fait, attribut `background` de l'élément `header`. On le voit en affichant les _rules_ CSS appliquées à la page, l'image est <https://romulusfr.github.io/unc-s2-web-ihm/assets/images/header-bg.jpg>
- Idem, mais cette fois c'est l'attribut `content` du pseudo sélecteur `h2::before`
- avec le fragment `#programme` le navigateur nous positionne directement sur le `<h2 id="programme">Programme</h2>` via l'id. La page n'est pas rechargée (rien ne change dans _Network_)
- oui, c'est le bandeau de droite avec _This page was generated by GitHub Pages._ (et je ne sais pas comment l'enlever...)
- aucune, ça se passe 100% côté client.
- on sélectionne avec Ctrl-Shift-C et on édite dans l'inspecteur. Pour l'ajout, passez par _Edit as HTML_
- oui

## Analyse de la trace `loopback.pcapng`

- élimine le traffic UDP (et donc DNS)
- 10 requêtes HTTP, toutes `GET`, utiliser le filtre `http.request` pour le vérifier
- l'icône qui sera associée au site par le navigateur
- ce qui différencie :
  - 60 vs 72 : `/` versus `/favicon.ico`
  - 60 vs 80 : le port 80 vs 8080 (pas le même serveur)
  - 60 vs 168 : le path de la requête **et** le navigateur
  - 168 vs 202 : le path, et accessoirement l'IP (v4 versus v6)
  - 259 vs 407 : le header `host` qui manque (et qui est necessaire)
- aucun, c'est fait à la main en `telnet` : on voit qu'il n'y a aucun header
- Chromium v91 et Firefox v89, tous les deux en anglais (header `Accept-Language: en-GB`)

- On regarde les headers `Server` des réponses:
  - `SimpleHTTP/0.6 Python/3.9.6` sur le port 8000
  - `Nginx` sur le port 80
- 400 et 404, filtrer avec `http.response.code >=400`
- le _directory listing_ du dossier `/2020/` avec 4 liens vers des fichiers ou dossiers. Faire clic-droit _follow/HTTP stream_ pour un affichage
- une page `<?php phpinfo(); ?>`, l'enregistrer avec l'interface de _follow/HTTP stream_, voir le fichier `phpinfo.html`
  - 7.4.3
  - Linux 5.8.0-59-generic sur x86_64
  - Variable `USER` qui vaut `www-data`
  - Frank Denis
  - 78 993 octets

## Analyse de la trace `enp0s31f6.pcapng`

- `perdu.com` à l'IP `208.97.177.124` et `httpbin.org` à l'IP `52.201.75.114`
- ça ne marche pas directement : il y a des infos en plus, dont le `Host` en particulier. En faisant une requête `telnet` à la main avec le hôte, c'est OK.
- on enregistre soit depuis le navigateur soit depuis Wireshark. Pas de `<!DOCTYPE html>` ni d'attribut `lang="fr"` (et aussi un charset Windows)
- réponse HTTP 418 à `Fri, 16 Jul 2021 01:03:56 GMT`, soit 12:03 locale.
- quand il y a un service web qui n'est pas encore implémenté mais dont a déjà prévu le chemin
- `Show Packet Bytes` et on voit un cochon qui rougit, voir `image.png`

